
var
a, pi, y, c, i, g,i_g , n, k, k_g ,b ,w,tau_w, tau_k, tau_c, rk ,r ,mc, f_g
f_i_g, f_tau_w ,f_tau_k, f_tau_c, r_not ;
 
varexo 
epsilon_a,  epsilon_f_i_g,  epsilon_f_g , epsilon_f_tau_w , epsilon_f_tau_k,
epsilon_f_tau_c , epsilon_f_r;
 
 
parameters A ,PI, Y, C, I, G, I_G, N, K,  B ,W, RK, R ,TAU_K, TAU_W ,TAU_C, sigma, phi, alpha ,betab ,theta ,eta ,delta_k, delta_kg , phi_i_g_y, phi_g_y, phi_tau_w_y, phi_tau_k_y, phi_tau_c_y,
            phi_i_g_b,  phi_g_b,  phi_tau_w_b,  phi_tau_k_b ,phi_tau_c_b,
            rho_f_i_g, rho_f_g,   rho_f_tau_w, rho_f_tau_c,
            rho_f_tau_k , rho_r , rho_pi rho_y, rho_a ;

sigma=2;  phi=2;A=1; PI=1;N=0.33; alpha=0.585; betab=0.998; theta=0.67;eta=0.06 ;TAU_K=0.22; TAU_W=0.07; TAU_C=0.125; R=1.01;
 RK=0.256;  delta_k=0.16; delta_kg=0.05; Y=159141.184206;
W=68421.44772; C=61246.26; I=68039.80;G=9436.309776;I_G=20418.81443;B=22437.58289;
K=425248.75;
phi_i_g_y=0.2926;
 phi_g_y=0.4561;
 phi_tau_w_y=0.5222;
 phi_tau_k_y=1.5063;
 phi_tau_c_y=0.7834;
 phi_i_g_b=0.1377;
  phi_g_b =0.3595;
 phi_tau_w_b=0.2480;
 phi_tau_k_b =0.0818;
phi_tau_c_b=1.5063;
 rho_f_i_g =0.9815;
rho_f_g=0.1182; 

rho_f_tau_w =0.6546;
rho_f_tau_c=0.8756;        
rho_f_tau_k =0.9742;
 rho_r =0.75;
rho_pi=0.65;
 rho_y =0.15;
rho_a=0.8;



model(linear);

sigma*(c(+1)-c)+TAU_C/(1+TAU_C)*(tau_c(+1)-tau_c)=r-pi(+1);
sigma*c+TAU_C/(1+TAU_C)*tau_c+phi*n=-TAU_W/(1-TAU_W)*tau_w+w;
(1-TAU_K)*RK*(-TAU_K/(1-TAU_K)*tau_k(+1)+rk(+1))=R/PI*(r-pi(+1));


a=rho_a*a(-1)+epsilon_a;
y=a+alpha*k(-1)+(1-alpha)*n+eta*k_g(-1);
k=(1-delta_k)*k(-1)+delta_k*i;
k_g=(1-delta_kg)*k_g(-1)+delta_kg*i_g;
rk+k(-1)=w+n;
mc=-a+(1-alpha)*w+alpha*rk-eta*k_g(-1);
pi=betab*pi(+1)+(1-betab*theta)*(1-theta)/theta*mc;
G*g+I_G*i_g+R*B*(r(-1)+b(-1))=TAU_C*C*(tau_c+c)+TAU_K*RK*K*(tau_k+rk+k(-1))
+TAU_W*W*N*(tau_w+w+n)+B*b;
r_not=rho_r*r_not(-1)+rho_pi*pi(+1)+rho_y*y+epsilon_f_r;
r=r_not;

i_g=-phi_i_g_y*y-phi_i_g_b*b(-1)+f_i_g;
f_i_g=rho_f_i_g*f_i_g(-1)+epsilon_f_i_g;
g=-phi_g_y*y-phi_g_b*b(-1)+f_g;
f_g=rho_f_g*f_g(-1)+epsilon_f_g;
tau_w=phi_tau_w_y*y+phi_tau_w_b*b(-1)+f_tau_w;
f_tau_w=rho_f_tau_w*f_tau_w(-1)+epsilon_f_tau_w;
tau_k=phi_tau_k_y*y+phi_tau_k_b*b(-1)+f_tau_k;
f_tau_k=rho_f_tau_k*f_tau_k(-1)+epsilon_f_tau_k;
tau_c=phi_tau_c_y*y+phi_tau_c_b*b(-1)+f_tau_c;
f_tau_c=rho_f_tau_c*f_tau_c(-1)+epsilon_f_tau_c;
Y*y=C*c+I*i+G*g+I_G*i_g;
end;
initval;
a=0; tau_c=0; tau_k=0; tau_w=0; c=0; r=0; n=0; w=0; rk=0;
y=0; k=0; k_g=0; i=0; i_g=0; b=0; g=0; f_i_g=0; f_g=0;
f_tau_w=0; f_tau_k=0; f_tau_c=0; mc=0; pi=0; r_not=0;
end;

shocks;

 var epsilon_a; stderr 1;
 var epsilon_f_i_g; stderr 1;
 var epsilon_f_g; stderr 1;
var epsilon_f_tau_w; stderr 1;
var epsilon_f_tau_k; stderr 1;
 var epsilon_f_tau_c; stderr 1;
var epsilon_f_r; stderr 1;

end ;
check;
stoch_simul(order=1,nocorr,nomoments,irf=0);
//stoch_simul(irf=20, nograph) ;



